unit mMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, shell;

type

  { TmForm }

  TmForm = class(TForm)
    TheShell: TShell;
    CMDEdit: TEdit;
    ShellMemo: TMemo;
    procedure CMDEditKeyPress(Sender: TObject; var Key: char);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TheShellOutput(Output: TStringlist);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  mForm: TmForm;

implementation

{ TmForm }

procedure TmForm.CMDEditKeyPress(Sender: TObject; var Key: char);
begin
  if Key = #13 then begin
    TheShell.SendCommand(CMDEdit.Text);     // Einen Befehl zur Bash senden.

                                            // Befehle wie EXIT müssten extra abgefangen werden, weil z.b.
                                            // die Shell beendet.
    CMDEdit.Text := '';
  end;
end;

procedure TmForm.FormCreate(Sender: TObject);
begin
  TheShell := TShell.Create(mForm, 'bash'); // Statt Bash könnte man auch SH oder ZSH nehmen;
                                            // Auch irgendein anderes Befehlszeilen Programm
                                            // wie z.b. MPLAYER könnte verwendet werden.

  TheShell.OnOutput := @TheShellOutPut;     // Hier wird die Ausgabe gelesen.
end;

procedure TmForm.FormDestroy(Sender: TObject);
begin
  TheShell.Destroy();                       // Die Shell beenden.
end;

procedure TmForm.TheShellOutput(Output: TStringlist);
var I: integer;
begin
  for I:=0 to Output.Count-1 do begin
    ShellMemo.Lines.Add(Output[I]);
  end;
end;

initialization
  {$I mmain.lrs}

end.

